$fn = 20;

plateWidth = 14;
plateHeight = 35;
plateThickness = 1;

springClearanceHeight = 25;

clearance = 0.2; // tried 0.1, 0.2, 0.3: 0.2 is Goldilocks

wallThickness = 1.5;
topPacking = 2;
frontPacking = 2;
backPacking = 1;

motorWidth = 11;

pinDia = 0.8;

difference() {
    union() {
        cylinder(d = plateWidth + 2 * clearance + 2 * wallThickness, h = 0.5); // skirt for printing stability
        translate([-plateWidth / 2 - clearance - wallThickness,
            -plateThickness / 2 - clearance - frontPacking, 
            0
        ])    
            cube([plateWidth + 2 * clearance + 2 * wallThickness, 
            plateThickness + 2 * clearance + frontPacking + backPacking, 
            plateHeight + clearance + topPacking
        ]);
        mirror([0, 1, 0])
        translate([motorWidth / 2, plateThickness / 2 + clearance + frontPacking - 0.1, plateHeight + clearance + topPacking - (plateHeight - springClearanceHeight) / 2 - 10])
            pinLatch();
    }

    translate([-plateWidth / 2 - clearance, -plateThickness / 2 - clearance, topPacking - clearance])
        cube([plateWidth + 2 * clearance, plateThickness + 2 * clearance, plateHeight + 10]);

    translate([-plateWidth / 2 - clearance, -plateThickness / 2 - clearance, topPacking - clearance + 2])
        cube([plateWidth + 2 * clearance, 20, springClearanceHeight - 2]);
    
    translate([-motorWidth / 2, -10, topPacking + 2])
        cube([motorWidth, 20, plateHeight + 5]);

    translate([(motorWidth + plateWidth) / 4 + 0.2, -10, plateHeight + clearance + topPacking - (plateHeight - springClearanceHeight) / 2])
        rotate([-90, 0, 0])
            cylinder(d = pinDia, h = 20);
}

module pinLatch() {
    difference() {
        union() {
            translate([0, 0.6, 0])
                cube([3, 2.4, 8]);
            translate([1.6, 0, 0])
                cube([1.4, 3, 8]);
        }
        translate([1.2, 1.1, -1])
            cylinder(d = 1.2, h = 10);
        
        rotate([0, -20, 0])
            translate([-8, -1, -5])
                cube([10, 5.2, 20]);

        rotate([-40, 0, 0])
            translate([0, 0, -1])
                cube([7, 7, 7]);
    }    
}
        