$fn = 30;

motorShaftDia = 3.2;
motorShaftFlat = 2.6; // 'diameter' to flat
motorShaftLength = 10;
bushDia = 4.5; // bush around shaft
bushLength = 1.0;
fixingHoleCentres = 9.0;
fixingHoleDia = 1.4;

plateWidth = 14;
plateHeight = 35;
plateThickness = 1;
motorFromBottom = 8;

crankThrow = 5;
springDia = 5;
springLength = 18;
pinDia = 1;

screwLength = 5.5; // shank
screwDia = 1.9;
wireDia = 1;
wireLength = 7;
/*
color([1, 0, 0])
    translate([0, crankThrow, plateThickness + 0.5])
        cylinder(d = pinDia, h = springDia + 1);

color([0, 1, 0])
    translate([0, crankThrow + springLength, plateThickness + 1 + springDia / 2])
        rotate([0, 90, 0])
            translate([0, 0, -plateWidth / 2])
                cylinder(d = pinDia, h = plateWidth);
*/
plate();
// motor();
// crank();

module plate() {
    difference() {
        union() {
            translate([-plateWidth / 2, -motorFromBottom, 0])
                cube([plateWidth, plateHeight, plateThickness]);

            translate([-1.2, crankThrow + springLength - 2.5, 0])
                cube([1, 5, plateThickness + springDia]);

            translate([0.2, crankThrow + springLength - 2.5, 0])
                cube([1, 5, plateThickness + springDia]);
        }
        translate([0, crankThrow + springLength, plateThickness + 1 + springDia / 2])
            rotate([0, 90, 0])
                translate([0, 0, -plateWidth / 2])
                    cylinder(d = pinDia, h = plateWidth);

        translate([0, -fixingHoleCentres / 2, -1])
            cylinder(d = fixingHoleDia, h = plateThickness + 2);

        translate([0, fixingHoleCentres / 2, -1])
            cylinder(d = fixingHoleDia, h = plateThickness + 2);

        translate([0, 0, -1])
            cylinder(d = bushDia, h = plateThickness + 2);
    }
}

module crank() {
    translate([0, 0, plateThickness + springDia / 2 + 1]) {
        difference() {
            union() {
                hull() {
                    cylinder(d = motorShaftDia + 2, h = 2);
                    translate([crankThrow, 0, 0])
                        cylinder(d = pinDia + 2, h = 2);
                }
                cylinder(d = motorShaftDia + 2, h = motorShaftLength - plateThickness - springDia / 2 + 2);
                cylinder(d = wireDia + 3, h = motorShaftLength - plateThickness - springDia / 2 + 1 + wireLength); // drivewire tube
        
                translate([0, 0, motorShaftLength - plateThickness - springDia / 2 + 1 + wireLength / 2])
                    rotate([0, 90, 0])
                        translate([0, 0, wireDia / 2])
                            cylinder(d = wireDia + 3, h = screwLength); // boss for screw

                    translate([crankThrow, 0, 0])
                        cylinder(d = pinDia + 2, h = motorShaftLength - plateThickness - springDia / 2 + 1 + wireLength / 2);
            }

            translate([0, 0, motorShaftLength - plateThickness - springDia / 2 + 1 + wireLength / 2])
                rotate([0, 90, 0])
                    translate([0, 0, wireDia / 2 + screwLength - 0.1])
                        cylinder(d = wireDia + 5, h = screwLength); // boss for screw

            translate([0, 0, -plateThickness - springDia / 2])
                motor();
            
            translate([crankThrow, 0, -1])
                cylinder(d = pinDia, h = motorShaftLength - plateThickness - springDia / 2 + 1 + wireLength / 2);

            translate([0, 0, motorShaftLength - plateThickness - springDia / 2 + 1])
                cylinder(d = wireDia, h = wireLength + 5);

            translate([0, 0, motorShaftLength - plateThickness - springDia / 2 + 1 + wireLength / 2])
                rotate([0, 90, 0])
            cylinder(d = screwDia, h = wireDia / 2 + screwLength + 5);
            
        }
    }
}

module motor() {
    union() {
        difference() {
            cylinder(d = motorShaftDia, h = motorShaftLength);
            translate([motorShaftFlat - motorShaftDia / 2, -motorShaftDia, -1])
                cube([motorShaftDia, 2 * motorShaftDia, motorShaftLength + 2]);
        }
        cylinder(d = bushDia, h = bushLength);
    }
    translate([0, -fixingHoleCentres / 2, 0])
        cylinder(d = fixingHoleDia, h = motorShaftLength);
    translate([0, fixingHoleCentres / 2, 0])
        cylinder(d = fixingHoleDia, h = motorShaftLength);
}